﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TuiBase
{
    public class CheckBox : Control
    {

        public bool Checked { get; set; }



        protected override void OnPaint()
        {
            string text = Text ?? string.Empty;

            ushort color = ConsoleColor.Attr(Foreground, Background);
            uint w;
            Coord pos = new Coord(Location.X, Location.Y);

            text = string.Format("[{0}] {1}", Checked ? "X" : " ", text.Length > Size.X - 4 ? text.Substring(0, Size.X - 4) : text.PadRight(Size.X - 4));
            Cons.WriteConsoleOutputCharacterEncoded( text, (uint)text.Length, pos, out w);
            Cons.FillConsoleOutputAttribute(Cons.ConsoleHandle,color, (uint)text.Length, pos, out w);

        }


        protected override void OnActivate()
        {
            base.OnActivate();
            Console.SetCursorPosition(Location.X + 1, Location.Y);
            Console.CursorVisible = true;
        }

        protected override void OnDeactivate()
        {
            base.OnDeactivate();
            Console.CursorVisible = false;
        }

        protected override bool OnKeyPress(ConsoleKeyInfo keyInfo)
        {
            if (base.OnKeyPress(keyInfo))
                return true;
            else
            {
                Coord pos = new Coord(Location.X + 1, Location.Y);
                ushort color = ConsoleColor.Attr(Foreground, Background);
                uint w;

                if (keyInfo.Key == ConsoleKey.Spacebar)
                {
                    Checked = !Checked;
                    Cons.WriteConsoleOutputCharacterEncoded(Checked ? "X" : " ", 1, pos, out w);
                    Cons.FillConsoleOutputAttribute(Cons.ConsoleHandle, color, 1, pos, out w);
                    return true;
                }
                return false;
            }
        }
    }
}
