﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TuiBase
{
    public class MessageBox : Window
    {
        TextPanel _textPanel;
        public MessageBox(string title, string[] lines)
        {
            int width = lines.Max(l => l.Length);
            Text = title;
            _textPanel = new TuiBase.TextPanel();
            _textPanel.Size = new TuiBase.Coord(Math.Max(3, width),Math.Max(3, lines.Length));
            _textPanel.Foreground = ConsoleColor.White;
            _textPanel.Background = ConsoleColor.Red;
            _textPanel.Lines = lines;
            
            Location = new TuiBase.Coord(5, 5);
            AddControl(_textPanel, new TuiBase.Coord(0,0 ));
            Size = _textPanel.Size + new TuiBase.Coord(2, 2);
        }

        public static DialogResultType Show(string title, string[] lines)
        {
            MessageBox b = new MessageBox(title,lines);
            return b.ShowDialog();
        }

        public static DialogResultType Show(string title, string[] lines,ushort background)
        {
            MessageBox b = new MessageBox(title, lines);
            b.Foreground = ConsoleColor.Gray;
            b.Background = background;
            return b.ShowDialog();
        }

        public static DialogResultType Show(string title, string[] lines, ushort background,ushort foreground)
        {
            MessageBox b = new MessageBox(title, lines);
            b.Foreground = foreground;
            b.Background = background;
            return b.ShowDialog();
        }


    }
}
